/***************************************************************************
                          susehwitemhandler.h  -  description
                             -------------------
    copyright            : (C) 2002 SuSE AG 
    email                : Oliver.Ries@suse.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef SUSEHWITEMHANDLER_H
#define SUSEHWITEMHANDLER_H

#include <hd.h>
#include <kconfig.h>
#include <kdirwatch.h>
#include <kprocess.h>

#include <qwidget.h>
#include <qfileinfo.h>
#include <qstringlist.h>
#include <qmap.h>
#include <qdict.h>
#include <qradiobutton.h>
#include <qlineedit.h>
#include <qcheckbox.h>
#include "susehwitem.h"

class SuSEhwItemHandler : public QObject 
{
Q_OBJECT

public: 
	SuSEhwItemHandler(QWidget *par, KConfig *conf, char *name);
	~SuSEhwItemHandler();

	void 	start();
	enum State { Idle, ItemFound };
	State	state();
	QWidget *getConfigureWidget(QWidget *parent);
	void 	ConfigOk();
	void	ConfigCancel();
	QString	getAppName();

protected:
	void 	AutoStartActive( bool a );

private:
	QDict<SuSEhwItem> items;
	QMap<QString, QString>		mWatchMap;
	QMap<QString, QTime>		fileTime;
	QString 			host;
	QString				display;
	bool				dialogdisplayed;
	QDict<SuSEhwItem>       	dialogQueue;
	KConfig				*config;
	QWidget 			*parent;
	State				mState;
	KDirWatch 			*dirwatch;	
	QMap<QString, QString>		mFstab;
	QTimer				*mTimer;
	QTimer				*desktopDirTimer;
        feat                            features;
	void 				launchDialog();
	void 				readConfig();
	void 				init(KConfig *conf);
	void 				addtoItemMap(hd_t *p);
	void 				addtoItemMap(QString id);
	void 				refreshItemInMap(QString id);
	void 				removefromMap(QString id);

	QString 			appname;
	
	QWidget				*mConf;	
	QLabel	*pixmapPatchCD,
		*pixmapCD,
		*pixmapCDR,
		*pixmapCDA,
		*pixmapDVD,
		*pixmapHDD,
		*pixmapCAM,
		*pixmapAutoRun;
        QCheckBox
		*chkBoxPatchCD,
		*chkBoxCD,
		*chkBoxCDR,
		*chkBoxCDA,
		*chkBoxDVD,
		*chkBoxHDD,
		*chkBoxCAM,
		*chkBoxAutoRun;
        QLineEdit
		*lineEditCD,
		*lineEditCDA,
		*lineEditCDR,
		*lineEditDVD,
		*lineEditCAM,
		*lineEditHDD;
	QLabel
		*labelAutoRun,
		*labelPatchCD;
        QCheckBox *chkBoxAutostart, *chkBoxAutoStartOnLogin, *chkBoxHardware;
	QCheckBox *chkBoxUseAutoStartApp, *chkBoxActivePolling;  

public slots:
	void 	slot_dirty(const QString &id);
	void 	queueDialogforPopup(SuSEhwItem *p);
        void 	queuedDialogDone(SuSEhwItem *p, bool show);
	void	removeItem(QString unique_id);
	void	AutoStartClicked();
	void	startupFinished();
	void    desktopDirEvent(const QString&);
	void    rescanDesktopDir();

signals:
	void	statusChanged();
};
#endif
